<?php
header("Content-type:application/xhtml+xml");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de-DE">
  <head>
    <link rel="stylesheet" type="text/css" href="vTnT.css" />
    <title>JavaScript-OOP</title>
    <script type="text/javascript" src="litebox-1.0/js/prototype.js"></script>
    <script type="text/javascript" src="class.Avatar.js"></script>
    <script type="text/javascript" src="class.AvatarCollection.js"></script>    
    <script type="text/javascript" src="class.VisualMap.js"></script>    
    <script src="src/js/log4js.js" type="text/javascript"></script> 
    <script type="text/javascript"><![CDATA[

      //initialize the logger  with your category 
      var logger = Log4js.getLogger("vtntTest"); 
      //set the level of logging 
      logger.setLevel(Log4js.Level.ALL); 
      //set the Appender to write the log to 
      logger.addAppender(new ConsoleAppender(logger, true)); 

    // some facts
   	var svgNS = 'http://www.w3.org/2000/svg';
    var xhtmlNS = 'http://www.w3.org/1999/xhtml';
  	var xlinkNS = 'http://www.w3.org/1999/xlink';
    var iAktiveSeconds = 120;

// and get it to work  
    var myAvatar = new Avatar();
    myAvatar.setX(140);
    myAvatar.setY(20);    
    myAvatar.setId("moin");
  	myAvatar.setName("myName");
  	myAvatar.setActive(true);
  	myAvatar.setLoudness(40);
  	myAvatar.setOwn(true);
  	myAvatar.setLastAction("2006");
  	myAvatar.setLastMoved("2006-12-12");
  	myAvatar.setLastSeen("2006-12-12");

    var myAvatar2 = new Avatar();
    myAvatar2.setX(121);
    
    myAvatar2.setY(121);    
    myAvatar2.setId("main");
  	myAvatar2.setName("moesName");
  	myAvatar2.setActive(true);
  	myAvatar2.setLoudness(40);
  	myAvatar2.setOwn(false);
  	myAvatar2.setLastAction("2007");
  	myAvatar2.setLastMoved("2007-12-12");
  	myAvatar2.setLastSeen("2007-12-12");

    var aCol = new AvatarCollection();
    aCol.add(myAvatar);
    aCol.add(myAvatar2);
    
    var oVMap = new VisualMap();
    oVMap.setWidth("320");
    oVMap.setHeight("240");
    
    oVMap.add(aCol);  

    
        var SVGDocument = null;
        var SVGRoot = null;
  
        var TrueCoords = null;
        var Translation = null;
        var TranslationX = null;
        var TranslationY = null;
        var GrabPoint = null;
        var BackDrop = null;
        var DragTarget = null;
        var DragType = 1;
  
        function Init(evt)
        {
           logger.debug("SVG-Javascript inited");
           // SVGDocument = document.getElementById('vTnTMap').ownerDocument;
      		 // SVGRoot = evt.target;
      		 // SVGRoot = oVMap.paint();
           // these svg points hold x and y values...
           //    very handy, but they do not display on the screen (just so you know)
           TrueCoords = SVGRoot.createSVGPoint();
           GrabPoint = SVGRoot.createSVGPoint();
           // this will serve as the canvas over which items are dragged.
           //    having the drag events occur on the mousemove over a backdrop
           //    (instead of the dragged element) prevents the dragged element
           //    from being inadvertantly dropped when the mouse is moved rapidly
           BackDrop = SVGDocument.getElementById('BackDrop');
      }

      function Grab(evt)
      {
         // find out which element we moused down on
         var targetElement = evt.target;
/*         SVGDocument.getElementById("mouseups").firstChild.data = "grabbed.";*/
          // der angewhlte Punkt ist der eigene Massepunkt
    		  if ((targetElement.getAttribute('class') == 'ava_body'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ))
          { 
    		  	targetElement = aCol.detect( function(value) {
                return value.getId() == targetElement.parentNode.id;
            });

            logger.debug("grabbing "+evt.target.id+" for moving and got ");    		  	
            targetElement.setMovingType(1);
            DragType = 1;
    		  } else {
            // der gewhlte Punkt ist der eigene Umkreis 
            if (targetElement.getAttribute('class') == 'ava_loudness'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ) {
    
          		  	targetElement = aCol.detect( function(value) {
                    return value.getId() == targetElement.parentNode.id;
                });
                targetElement.setMovingType(2);
    		  	    DragType = 2;
                logger.debug("grabbing "+evt.target.id+" for resizing.");                
              }
              else
                targetElement = null;
          }
          
    		  if ( targetElement == SVGRoot)
    		 	  targetElement = null;

         // you cannot drag the background itself, so ignore any attempts to mouse down on it
         if ( targetElement != null && BackDrop != targetElement )
         {
            //set the item moused down on as the element to be dragged
            DragTarget = targetElement;
            DragTarget.setMovingType(DragType);

            // move this element to the "top" of the display, so it is (almost)
            //    always over other elements (exception: in this case, elements that are
            //    "in the folder" (children of the folder group) with only maintain
            //    hierarchy within that group
//            DragTarget.parentNode.appendChild( DragTarget );

            // turn off all pointer events to the dragged element, this does 2 things:
            //    1) allows us to drag text elements without selecting the text
            //    2) allows us to find out where the dragged element is dropped (see Drop)

            // we need to find the current position and translation of the grabbed element,
            //    so that we only apply the differential between the current location
            //    and the new location
            //var transMatrix = DragTarget.getCTM();
            //GrabPoint.x = TrueCoords.x - Number(transMatrix.e);
            //GrabPoint.y = TrueCoords.y - Number(transMatrix.f);
            GrabPoint.x = TrueCoords.x - DragTarget.getX();
            GrabPoint.y = TrueCoords.y - DragTarget.getY();


         }
      };


      function Drag(evt)
      {
         // account for zooming and panning
         GetTrueCoords(evt);
         // if we don't currently have an element in tow, don't do anything
         // wir haben den Massepunkt
         if (DragTarget&&DragTarget.getMovingType() == 1)
         {
            // account for the offset between the element's origin and the
            //    exact place we grabbed it... this way, the drag will look more natural
            var newX = TrueCoords.x - GrabPoint.x;
            var newY = TrueCoords.y - GrabPoint.y;

            // apply a new tranform translation to the dragged element, to display
            //    it in its new location
            DragTarget.setX(newX);
            DragTarget.setY(newY);
         }

          // wir haben den Umkreis
         if (DragTarget&&DragTarget.getMovingType() ==2)
         {
            // account for the offset between the element's origin and the
            //    exact place we grabbed it... this way, the drag will look more natural
            var newX = TrueCoords.x - GrabPoint.x - SVGRoot.currentTranslate.x;
            var newY = TrueCoords.y - GrabPoint.y - SVGRoot.currentTranslate.y;

            // apply a new tranform translation to the dragged element, to display
            //    it in its new location
            DragTarget.setLoudness(
                Math.round(
                  Math.sqrt(
                    Math.pow((TrueCoords.x - DragTarget.getX()),2)
                    +Math.pow((TrueCoords.y - DragTarget.getY()),2)
                    )
                )
            );
         }


      };


      function Drop(evt)
      {
         // if we aren't currently dragging an element, don't do anything
         if ( DragTarget )
         {
            // since the element currently being dragged has its pointer-events turned off,
            //    we are afforded the opportunity to find out the element it's being dropped on
            var targetElement = evt.target;
          
            //genderter Radius
            if ( DragTarget.getMovingType() == 2 )
            {
/*               DragTarget.setAttributeNS(null, 'pointer-events', 'visibleStroke');*/
  
  /*          	 var aktTransform = DragTarget.parentNode.getAttributeNS(null,'transform');*/ 
  
               logger.debug(DragTarget.getId() + ' has now a changed Radius ' + targetElement.id 
               +' and has the following XY '+DragTarget.getX()+" "+DragTarget.getY());
              
                DragTarget.setMovingType(0);
                DragTarget.notify();
                DragTarget = null;
            }
            else
            {
                // turn the pointer-events back on, so we can grab this item later
               // for this example, you cannot drag an item out of the folder once it's in there;
               //    however, you could just as easily do so here

/*            	 DragTarget.setAttributeNS(null, 'pointer-events', 'visiblePainted');*/

/*               var aktTransform = DragTarget.getAttributeNS(null,'transform');*/
               logger.debug(DragTarget.getId() + ' has been dropped on top of ' + targetElement.id 
               +' and has the following XY '+DragTarget.getX()+","+DragTarget.getY());

                //var aktTransX = aktTransform.substring((aktTransform.indexOf('(')+1),aktTransform.indexOf(','));
		            //var aktTransY = aktTransform.substring((aktTransform.indexOf(', ')+1),aktTransform.indexOf(')'));

/*               xajax_setNewPosition( DragTarget.id, aktTransX, aktTransY, "", "");
               xajax_updateChat(myAvatar, active, lastMessage); 
*/

/*            	 document.getElementById('xPosition').value = aktTransX;
            	 document.getElementById('yPosition').value = aktTransY;*/  
              DragTarget.setMovingType(0);
              DragTarget.notify();
              DragTarget = null;
            }

            // set the global variable to null, so nothing will be dragged until we
            //    grab the next element
         }
      };


      function GetTrueCoords(evt)
      {
         // find the current zoom level and pan setting, and adjust the reported
         //    mouse position accordingly
         var newScale = SVGRoot.currentScale;
         var translation = SVGRoot.currentTranslate;
         logger.debug("Translation"+translation.x+" "+translation.y);
         TrueCoords.x = ((evt.clientX - translation.x)/newScale);
         TrueCoords.y = ((evt.clientY - translation.y)/newScale);
/*         SVGDocument.getElementById("mouseups").firstChild.data = "Cords= " + TrueCoords.x + " / " + TrueCoords.y;*/
      };

   ]]></script>

  </head>
  <body>
  <div id="vTnTVisual"> 
    <!-- svg 
  	width='640' height='480' 
    	xmlns='http://www.w3.org/2000/svg'
    	viewBox="0 0 640 480"
    	
     onload='Init(evt)'
     onmousedown='Grab(evt)'
     onmousemove='Drag(evt)'
     onmouseup='Drop(evt)'

    	
     name="hallo"
     id = "vTnTMap"
  	>
     <title>Playground of our new Chat-Version</title>
     <desc>
        This is just a boring, little test. Yes, definetly.
     </desc>
  	 <g id='Folder3' class='avatar moveable'>
		   <circle cx='125' cy='25' r='40' class="ava_loudness" />
		   <circle cx='125' cy='25' r='5' class="ava_body"/>
	   </g>

    </svg -->
  	</div>
    <script type="text/javascript"><![CDATA[
        document.getElementById('vTnTVisual').appendChild(oVMap.paint());
        SVGRoot = oVMap.paint();
        TrueCoords =  oVMap.getSVGPoint();
        GrabPoint =   oVMap.getSVGPoint();
        BackDrop = oVMap.paint();        
     ]]></script>
  <button onclick="oVMap.setCurrentScale('2');">ma guckn</button>
  <button onclick="oVMap.setTranslationX('80');">ma guckn2</button>  
  <button onclick="oVMap.setWidth('160');">ma guckn3</button>  
  </body>
</html>
