/**
 * class Controller
 *   
 * Der Controller ist die Eingabeschnittstelle zwischen Benutzer und Modell.
 * Er interpretiert die empfangenen Eingabedaten und bergibt sie dem Modell.
 * Ein Controller ist meist auf ein spezielles View zugeschnitten. Ist sein 
 * Verhalten vom Model abhaengig, so muss er auch auf �derungen im Model
 * reagieren koennen.
 * 
 * @author lray
 * @version 2007-02-16
 */    

  var AvatarControl = Class.create();

  AvatarControl.prototype = {

    oModel: Object(),
    oMap: Object(),
    oLogger:Object(),  
    sName: String("Controller"),


    SVGDocument:Object(),
    SVGRoot:Object(),
    myTranslation2:Object(),
    myScale:Object(),
    myTmpLoudness:Number(40),
    myDragable:Object(),        
    
    TrueCoords:Object(),
    Translation:Object(),
    TranslationX:Number(0),
    TranslationY:Number(0),
    GrabPoint:Object(),
    BackDrop:Object(),
    DragTarget:Object(),
    DragType:Number(1),
    
    _X_RESIZING_POSITION_:String("left"),
    _Y_RESIZING_POSITION_:String("top"),

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param oModel Mathematisches Modell
   */
    initialize: function( oModel, oMap )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel == null || oMap == null) {
          this.oLogger.warn("Control: entweder Modell oder View nicht bergeben, laufe im Leerlauf!")
      }
      
      this.oModel = oModel;
      this.oMap  = oMap;

      // SVG-Stuff
      this.SVGRoot = this.oMap.paint();
      this.TrueCoords =   this.oMap.getSVGPoint();
      this.GrabPoint =    this.oMap.getSVGPoint();
      this.BackDrop =     this.oMap.paint();  
      this.myTranslation2= this.oMap.getSVGPoint();
      
      this.myDragable = undefined;

//      this.TrueCoords = this.SVGRoot.createSVGPoint();
//      this.GrabPoint = this.SVGRoot.createSVGPoint();
      // this will serve as the canvas over which items are dragged.
      //    having the drag events occur on the mousemove over a backdrop
      //    (instead of the dragged element) prevents the dragged element
      //    from being inadvertantly dropped when the mouse is moved rapidly
      this.BackDrop = document.getElementById('BackDrop');

      
    },

  /**
   * Setzt Model und View zurck.
   */
    release: function()
    {
      this.oModel = null;
      this.oMap = null;
    },

    toString: function()
    {
      return this.sName;
    },
  /* --------------------------------------------------*/
  // handleEvent-Methode
  
        init:function(evt)
        {
           this.oLogger.debug("SVG-Javascript inited");
           // SVGDocument = document.getElementById('vTnTMap').ownerDocument;
      		 // SVGRoot = evt.target;
      		 // SVGRoot = oVMap.paint();
           // these svg points hold x and y values...
           //    very handy, but they do not display on the screen (just so you know)
      },

      over:function(evt)
      {
         //this.oLogger.debug("mouse sended 'over'");
         var targetElement = evt.target;
         if (targetElement.getAttribute('class') == 'ava_body'
             && targetElement.parentNode.getAttribute('class') == 'avatar')
            this.oModel.setDetailedUser(targetElement.parentNode.id);

         if (targetElement.getAttribute('class') == 'prod_body')
            this.oModel.setDetailedProduct(targetElement.id.substring(5));

         if (targetElement.parentNode.getAttribute('class') == 'prod_body') { 
          this.oModel.setDetailedProduct(targetElement.parentNode.id.substring(5));
          this.oLogger.info(targetElement.getAttribute('class')+"-"+targetElement.parentNode.id.substring(5));
         }
           
          
         if (targetElement.getAttribute('class') == 'prod_image') {
          this.oModel.setDetailedProduct(targetElement.id.substring(5));
          this.oLogger.info(targetElement.getAttribute('class')+"-"+targetElement.id.substring(5));
         }
         
      	Event.stop(evt);

      },
      
      out:function(evt)
      {
         var targetElement = evt.target;
         //this.oLogger.debug("mouse sended 'out'");
         if (targetElement.getAttribute('class') == 'ava_body'
             && targetElement.parentNode.getAttribute('class') == 'avatar')

            this.oModel.clearDetailedUser();
      	Event.stop(evt);

      },

      grab:function(evt)
      {
         // find out which element we moused down on
         var targetElement = evt.target;
/*         SVGDocument.getElementById("mouseups").firstChild.data = "grabbed.";*/
 
          // der angewaehlte Punkt ist der eigene Massepunkt
          if (targetElement.getAttribute('class') == 'prod_body')
            targetElement=this.SVGRoot;

    	  if ((targetElement.getAttribute('class') == 'ava_body'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ))
          { 
            targetElement = this.oMap.getView().detect( function(value) {
                return value.getId() == targetElement.parentNode.id;
            });

            this.oLogger.debug("grabbing "+evt.target.id+" for moving and got "+targetElement);    		  	
            targetElement.setMovingType(1);
            targetElement.setBlocked(true);
            targetElement.stopAnimation();
            this.DragType = 1;
    		 
    	  } else {
            // der gewaehlte Punkt ist der eigene Umkreis 
            if (targetElement.getAttribute('class') == 'ava_loudness'
              &&targetElement.parentNode.getAttribute('class')
              &&targetElement.parentNode.getAttribute('class').match(/moveable/) ) {
    
          		  	targetElement = this.oMap.getView().detect( function(value) {
                    return value.getId() == targetElement.parentNode.id;
                });
                
                targetElement.setMovingType(2);
    		  	this.DragType = 2;
                this.oLogger.debug("grabbing "+evt.target.id+" for resizing.");                
              }
              else
                if (targetElement == this.SVGRoot) {
                
                }
                else targetElement = this.SVGRoot;
          }
          
    		  //if ( targetElement == SVGRoot)
    		 	//  targetElement = null;
        
         // you cannot drag the background itself, so ignore any attempts to mouse down on it
         if ( targetElement != null 
            && this.BackDrop != targetElement
            && targetElement != this.SVGRoot )
         {
            //set the item moused down on as the element to be dragged
            this.DragTarget = targetElement;
            this.DragTarget.setMovingType(this.DragType);

            // move this element to the "top" of the display, so it is (almost)
            //    always over other elements (exception: in this case, elements that are
            //    "in the folder" (children of the folder group) with only maintain
            //    hierarchy within that group
//            DragTarget.parentNode.appendChild( DragTarget );

             // we need to find the current position and translation of the grabbed element,
            //    so that we only apply the differential between the current location
            //    and the new location
            //var transMatrix = DragTarget.getCTM();
            //GrabPoint.x = TrueCoords.x - Number(transMatrix.e);
            //GrabPoint.y = TrueCoords.y - Number(transMatrix.f);
            this.GrabPoint.x = this.TrueCoords.x - this.DragTarget.getX();
            this.GrabPoint.y = this.TrueCoords.y - this.DragTarget.getY();
            this.myTmpLoudness = this.DragTarget.getLoudness();
            this.oLogger.info("new tmpLoudness"+this.myTmpLoudness+"grabpoint:"+this.GrabPoint.x+":"+this.GrabPoint.y+"  "+this.DragTarget.getX()+":"+this.DragTarget.getY() );
         }

         if (targetElement == this.SVGRoot)
         {

          /*  this.GrabPoint.x = this.TrueCoords.x;
            this.GrabPoint.y = this.TrueCoords.y;*/ 

            this.GrabPoint.x = Math.round(this.oMap.getCurrentScale()*this.TrueCoords.x);
            this.GrabPoint.y = Math.round(this.oMap.getCurrentScale()*this.TrueCoords.y); 
            
            this.myTranslation2.x = (this.oMap.getTranslationX());
            this.myTranslation2.y = this.oMap.getTranslationY();
            this.oLogger.debug("grabbed Background["+this.GrabPoint.x
                +"("+this.myTranslation2.x+"),"
                +this.GrabPoint.y+"("+this.myTranslation2.y+")]");
            this.DragTarget = targetElement;       
         }
      	Event.stop(evt);
		
      },


      drag:function(evt)
      {
         if (this.DragTarget) {Event.stop(evt);} //Event wird nur dann nicht weitergegeben, wenn feststeht das ein Element der Map gedragged wird.         
        
         // account for zooming and panning
         this.getTrueCoords(evt);
         // if we don't currently have an element in tow, don't do anything
         // wir haben den Massepunkt
         if (this.DragTarget == this.SVGRoot) {
              var newX = this.TrueCoords.x - this.GrabPoint.x;
              var newY = this.TrueCoords.y - this.GrabPoint.y;
  
              this.oMap.setTranslationX(Number(((-1*newX))+(2*this.myTranslation2.x)));
              this.oMap.setTranslationY(Number(((-1*newY))+(2*this.myTranslation2.y)));          
              
              this.oLogger.info("grabbed Background["+this.GrabPoint.x
                +"("+this.oMap.getTranslationX()+"/"+this.myTranslation2.x+"),"
                +this.GrabPoint.y+"("+this.oMap.getTranslationY()+")]");
         }
         else {
            // wir haben den Body erwischt
           if ((this.DragTarget instanceof Avatar)&&this.DragTarget.getMovingType() == 1)
           {
              // account for the offset between the element's origin and the
              //    exact place we grabbed it... this way, the drag will look more natural
              var newX = this.TrueCoords.x - this.GrabPoint.x;
              var newY = this.TrueCoords.y - this.GrabPoint.y;
              var translation = this.SVGRoot.currentTranslate;
  
              // apply a new tranform translation to the dragged element, to display
              //    it in its new location
              this.DragTarget.setX(newX);
              this.DragTarget.setY(newY);
           }
  
            // wir haben den Umkreis
           if ((this.DragTarget instanceof Avatar)&&this.DragTarget.getMovingType() ==2)
           {
              // account for the offset between the element's origin and the
              //    exact place we grabbed it... this way, the drag will look more natural
              var newX = this.TrueCoords.x - this.GrabPoint.x - this.DragTarget.getX();
              var newY = this.TrueCoords.y - this.GrabPoint.y - this.DragTarget.getY();
              var newLoudness = Math.round( Math.sqrt( Math.pow(newX,2) + Math.pow(newY,2)));  
              // apply a new tranform translation to the dragged element, to display
              //    it in its new location
              this.oLogger.info("Radius-Anpassung X:"+newX+" Y:"+newY+" ergibt "+newLoudness);              
              //if ((newX + newY) > 0)
              	this.DragTarget.setLoudness(Number(this.myTmpLoudness) + Number(newLoudness) );
             // else
             // 	this.DragTarget.setLoudness(Number(this.myTmpLoudness) - Number(newLoudness) );
           }
        }
      },


      drop:function(evt)
      {
         // if we aren't currently dragging an element, don't do anything
         if ( this.DragTarget )
         {
            // since the element currently being dragged has its pointer-events turned off,
            //    we are afforded the opportunity to find out the element it's being dropped on
            var targetElement = evt.target;
          
            // bewege Hintergrund
            if (this.DragTarget == this.SVGRoot) {
                this.DragTarget = null;
            //  myTranslation = TrueCoords;
            }
            
            //geaenderter Radius
            if ( ( this.DragTarget instanceof Avatar)&&this.DragTarget.getMovingType() == 2 )
            {
/*               DragTarget.setAttributeNS(null, 'pointer-events', 'visibleStroke');*/
  
  /*          	 var aktTransform = DragTarget.parentNode.getAttributeNS(null,'transform');*/ 
  
                //@TODO bug-workaround -- start -- ler
               // this.oLogger.info("einzutragende Loudness:"+this.DragTarget.getLoudness());
               // if (this.DragTarget.getLoudness() > 100)
               //   this.DragTarget.setLoudness(100);
              //@TODO bug-workaround -- end -- ler
              
               this.oLogger.debug(this.DragTarget.getId() + ' has now a changed Radius on ' + targetElement.id 
               +' with size '+this.DragTarget.getLoudness()+' and has the following XY '+this.DragTarget.getX()+" "+this.DragTarget.getY());
              
              
                this.DragTarget.setMovingType(0);
                var oTmpModel = this.oModel.getUserById(this.DragTarget.getId());
                oTmpModel.setLoudness(this.DragTarget.getLoudness());
                
                this.DragTarget = null;
                
                oTmpModel.setLastMoved(-1);
                this.oModel.updateUser(oTmpModel, false);
            }
            else
            if ( ( this.DragTarget instanceof Avatar) && this.DragTarget.getMovingType() == 1 ){
                // turn the pointer-events back on, so we can grab this item later
               // for this example, you cannot drag an item out of the folder once it's in there;
               //    however, you could just as easily do so here

               this.oLogger.debug(this.DragTarget.getId() + ' has been dropped on top of ' + targetElement.id 
               +' and has the following XY '+this.DragTarget.getX()+","+this.DragTarget.getY());

              
              var oTmpModel = this.oModel.getUserById(this.DragTarget.getId());
              
              oTmpModel.setX(this.DragTarget.getX());
              oTmpModel.setY(this.DragTarget.getY());
              oTmpModel.setBlocked(false);
              
              ///////Nur zum Test
              alert("Nur zum Test: " + this.DragTarget.getX() + ", " + this.DragTarget.getY());
      
              
              
                this.oModel.setActualPageByPositionAndZoom(
              	this.DragTarget.getX(),
              	this.DragTarget.getY(),
              	this.oModel.getZoomLevel() );
              
              this.DragTarget.setMovingType(0);
              this.DragTarget = null;

              oTmpModel.setLastMoved(-1);
              this.oModel.updateUser(oTmpModel, false);
            
            } else
                this.DragTarget = null;
                this.oModel.setTranslationX(this.oMap.getTranslationX());
                this.oModel.setTranslationY(this.oMap.getTranslationY());
            // set the global variable to null, so nothing will be dragged until we
            //    grab the next element
         }
      	Event.stop(evt);
      },


      getTrueCoords:function (evt)
      {
         // find the current zoom level and pan setting, and adjust the reported
         //    mouse position accordingly
		
         var newScale = this.SVGRoot.currentScale;
         var translation = this.SVGRoot.currentTranslate;
         if ((this.DragTarget != this.SVGRoot)) {
           this.TrueCoords.x = ((evt.clientX - translation.x)/newScale);
           this.TrueCoords.y = ((evt.clientY - translation.y)/newScale);
         } else {
           this.TrueCoords.x = evt.clientX;
           this.TrueCoords.y = evt.clientY;
         }
         
         //this.oLogger.debug("Scale "+newScale+" Translation "+translation.x+","+translation.y+" with TrueCords "+TrueCoords.x+","+TrueCoords.y);
/*         SVGDocument.getElementById("mouseups").firstChild.data = "Cords= " + TrueCoords.x + " / " + TrueCoords.y;*/
      },
  
  
      setOwnUserLoudnessThroughWheel:function (evt)
      {
         // find the current zoom level and pan setting, and adjust the reported
         //    mouse position accordingly

         alert("nice");
         //}
         
         //this.oLogger.debug("Scale "+newScale+" Translation "+translation.x+","+translation.y+" with TrueCords "+TrueCoords.x+","+TrueCoords.y);
/*         SVGDocument.getElementById("mouseups").firstChild.data = "Cords= " + TrueCoords.x + " / " + TrueCoords.y;*/
      },
    
    getName: function() {
      return this.sName;
    },

    //Beginn Paste
      doWithUser:function(what2do) {
        
        var vTnTWidth = 168; //210;
        var vTnTHeight = 212; //210;
        var vTnTMaxWidth = 760;  //745
        var vTnTMaxHeight = 360; //360
        var vTnTVisualMaxWidth = 412;
        var vTnTVisualMaxHeight = 353; 
       
        switch (what2do) {
          case "mini":  
          				
                        var vTnTName = "vTnT";
                        var vTnT =  $(vTnTName);
                        var newYPos;

						if (this._Y_RESIZING_POSITION_ == "bottom") {
	                        if (this.oModel.getViewMode() != 0) {                       	
								newYPos = Number(vTnT.style.top.substring(0,(Number(vTnT.style.top.length-2))))+(vTnTMaxHeight-vTnTHeight); //150
	                        } else {
								newYPos = Number(vTnT.style.top.substring(0,(Number(vTnT.style.top.length-2))));                        
	                        };
                        
	                        //  vTnT.style.top = newYPos+"px";
	                        new Effect.Move( vTnT, {
	               				y: newYPos,
	               				x: vTnT.style.left, 
	               				mode: 'absolute',
	               				duration: 2.0,  
	               				transition: Effect.Transitions.slowstop,
	             			});
 						}

						if (this._X_RESIZING_POSITION_ == "right") {
	                        if (this.oModel.getViewMode() != 0) {                       	
	                        	vTnT.style.left = Number(Number(vTnT.style.left.substring(0,(Number(vTnT.style.left.length-2))))+(vTnTMaxWidth-vTnTWidth))+"px"; //535
	                        }
						}
						 						
						if (this._X_RESIZING_POSITION_ == "left") {
							$("vTnTVisual").style.float = "left";
						}

                        //vTnT.style.backgroundColor = "green";
						
						//Admin Panel fr die Zeit des DivResizeEffektes unsichtbar machen
						$("vTnTAdmin").style.display = "none";
                        
                        $("vTnTAdmin").style.position = "absolute";
                        $("vTnTAdmin").setAttribute("class","minimized");

                        $("vTnTAdmin").style.top = (vTnTHeight-15)+"px";
                        $("vTnTAdmin").style.right = "1px";
                        try {
                        	$("vTnTInputFormInput15").style.display ="none";
                        	$("vTnTInputFormInput18").style.display ="none";
                        	$("vTnTInputFormInput14").style.display ="inline";
                        } catch (e) {}                 
	                    
	                    try { 
		                	moveFrameToBody(); 
	                    } catch (e) { };
    					this.oModel.setViewMode(0);

						Element.makePositioned("vTnT");                        
                        
                        var vTnTBG = $("vTnTBackground");
                        $("vTnTIdControl").style.display = "none";
                        $("vTnTSlider").style.display = "none";
                        //$('vTnTChat').style.display = "none";                      


                        /*$("vTnTVisual").style.width = "180px";
                        $("vTnTVisual").style.height = "180px";*/
                        $("vTnTVisual").setAttribute("class","minimized");
                        
                        if (typeof(this.myDragable) != "undefined") { 
                        	this.myDragable.destroy();
                        	this.myDragable = undefined;
                        	$("vTnTVisual").style.top = "0px";
                        	$("vTnTVisual").style.left = "0px";
                        }
                        
                                                
                        //$("vTnTVisual").style.backgroundColor = "green";
                        vTnT.style.zIndex = 100;
                        vTnT.style.width = vTnTWidth+"px";
                        vTnT.style.height = vTnTHeight+"px";
                        //vTnT.style.backgroundColor = "yellow";
                        //vTnT.style.position = "static";

                        $('vTnTChatInteraction').style.display = "block";
                        
                  		/*$("vTnTAdmin").style.top = "";
                  		$("vTnTAdmin").style.left = "";			
                        $("vTnTAdmin").style.width = "";*/

                  			new Effect.DivResize( $("vTnTVisual"), {
                  				width: vTnTWidth,
                  				height: vTnTHeight, 
                  				mode: 'absolute',
                  				//float: 'right',
                  				verticalAlign: 'top', 
                  				duration: 2.0,  
                  				transition: Effect.Transitions.slowstop,
                  				queue: { 
                  					position:'end',
                  					scope: 'oMapResize'
                  					}			
                  				});
                        
                        new Effect.DivResize( $("vTnTMap"), {
               				width: vTnTWidth,
               				height: vTnTHeight, 
               				mode: 'absolute',
               				//float: 'left',
               		        //verticalAlign: 'top', 
               				duration: 2.0,  
               				transition: Effect.Transitions.slowstop,
               				queue: { 
               					//position:'front',
               					scope: 'oMapResize'
               				},
               				afterFinish: function() {$("vTnTAdmin").style.display = "inline";}
               			}); 
                        
                        $("vTnTAdminMain").style.display = "none";
                        $("vTnTAdminMini").style.display = "inline";
                        
                        vTnT.style.top = "";
                  		vTnT.style.left = "";
                  		vTnT.style.position = "";	
                        
                        try {new Effect.Fade('vTnTBackground', { duration: 0.2, from: 0.4, to: 0.0 });} catch (e) {};
						
						this.oModel.getOwnUser()[0].setActive(false);
                        this.oModel.updateUser(this.oModel.getOwnUser()[0], false);
                        break;   
    
          case "maxi":  
                        this.oModel.setIgnoreTextLines(false);
                        
                        // Hlt das uerste div offen, sodass die Elemente der linken Spalte nicht nach oben rutschen.
                        var vTnTName = "vtntpi1";
                        var vTnTBox = $(vTnTName);
          				if ( typeof(vTnTBox) != undefined) { 
          				  vTnTBox.style.height = vTnTHeight+"px";
          				}
          				
                        var vTnT =  $("vTnT");
                        vTnT.style.zIndex = 100;
                        //vTnT.style.width = "745px";
						vTnT.style.width = vTnTMaxWidth + "px";
						vTnT.style.height = vTnTMaxHeight + "px";
						Element.absolutize("vTnT");
						
						if (this._X_RESIZING_POSITION_ == "right") {
                        	vTnT.style.left = Number(vTnT.style.left.substring(0,(Number(vTnT.style.left.length-2)))-(vTnTMaxWidth-vTnTWidth))+"px";
                        	$("vTnTVisual").style.float = "right";
                        }

						if (this._X_RESIZING_POSITION_ == "left") {
							$("vTnTVisual").style.float = "left";
						}
                        
                        
                        /*vTnT.style.left = Number(vTnT.style.left.substring(0,(Number(vTnT.style.left.length-2)-210)))+"px";*/
                        $("vTnTChat").style.marginRight = "5px";
                        $("vTnTChat").style.opacity = "0.0";
                        /*$("vTnTChat").style.display = "inline";*/
                                              
                        //vTnT.style.height = "480px";                        
                        //vTnT.style.backgroundColor = "yellow";
                       // vTnT.style.position = "absolute";
                        //vTnT.style.padding = "20px 20px 20px 20px";
                        
                        var pageSize = getPageSize();
                        var vTnTName = "vTnT";
                        var vTnTBG = $("vTnTBackground");
                        
                        
                        this.oModel.setViewMode(1);

						// falls Fenster sich nach oben oeffnet.
						if (this._Y_RESIZING_POSITION_ == "bottom") {
	                        var newYPos = Number(vTnT.style.top.substring(0,(Number(vTnT.style.top.length-2)))-(vTnTMaxHeight-vTnTHeight)); 
	               			
	               			new Effect.Move( vTnT, {
	               				y: newYPos,
	               				x: vTnT.style.left, 
	               				mode: 'absolute',
	               				duration: 2.0,  
	               				transition: Effect.Transitions.slowstop,
	             				});
             			}
                        
                        new Effect.Appear('vTnTBackground', { 
                        		duration: 0.2, 
                        		from: 0.0, 
                        		to: 0.4,
                        		/*queue: { 
               						position:'end',
               						scope: 'oMapResize'
               					}*/
               					});
 
                        
                        try { moveBodyToFrame(); } catch (e) { this.oLogger.info("Couldn't switch to FrameMode");};
 
               			new Effect.DivResize( $("vTnTVisual"), {
               				width: vTnTVisualMaxWidth,
               				height: vTnTVisualMaxHeight, 
               				mode: 'absolute',
               				//float: 'right',
               				verticalAlign: 'top', 
               				duration: 2.0,  
               				transition: Effect.Transitions.slowstop,
               				queue: { 
               					//position:'front',
               					scope: 'oMapResize'
               					}			
               				});
               				
               			new Effect.DivResize( $("vTnTMap"), {
               				width: vTnTVisualMaxWidth,
               				height: vTnTVisualMaxHeight, 
               				mode: 'absolute',
               				//float: 'right',
               				//verticalAlign: 'top', 
               				duration: 2.0,  
               				transition: Effect.Transitions.slowstop,
               				queue: { 
               					//position:'end',
               					scope: 'oMapResize'
               					}			
               				}); 
               				   
               				new Effect.Appear('vTnTChat', { duration: 0.2, from: 0.0, to: 1.0, queue: { 
               						position:'end',
               						scope: 'oMapResize'
               					} });
                        
               				new Effect.Appear('vTnTIdControl', { duration: 0.2, from: 0.0, to: 1.0, queue: { 
               						position:'end',
               						scope: 'oMapResize'
               					} });
                         
                        $("vTnTChat").style.overflow = "hidden";

	                    vTnTBG.style.width  = pageSize[0]+"px";
                        vTnTBG.style.height = pageSize[1]+"px";

                       // $("vTnTIdControl").style.display = "block";
                        
                        $('vTnTChatInteraction').style.display = "none";
                        //$('vTnTInputForm').style.display = "block;";
                       // $("vTnTSlider").style.display = "block";

                        $("vTnTVisual").setAttribute("class","");
                        if (typeof(this.myDragable) == "undefined") { 
                        	this.myDragable = new Draggable('vTnTVisual');
                        }
                        //$("vTnTVisual").style.backgroundColor = "green";
                        
                        
                        //vTnT.style.height = 440+"px";
                        //vTnT.style.left = Number((pageSize[2] / 2)-380)+"px";        
                        //vTnT.style.top = Number((pageSize[3] / 2)-300)+"px";
                  
						//$("vTnTAdmin").setAttribute("class","opened");
                  		/*$("vTnTAdmin").style.position = "static";
                  		$("vTnTAdmin").style.left = "10px";			
                        $("vTnTAdmin").style.width = "420px";
                        $("vTnTAdmin").style.clear = "both";*/
                        $("vTnTAdmin").style.top = "0px";			
                       // $("vTnTAdminMain").style.display = "inline";
                       // $("vTnTAdminMini").style.display = "none";
                        
                        try {
                        	$("vTnTInputFormInput15").style.display ="inline";
                        	$("vTnTInputFormInput14").style.display ="none";
                        	$("vTnTInputFormInput18").style.display ="inline";
                        } catch (e) {};
                        
                        this.oModel.getOwnUser()[0].setActive(true);
                        this.oModel.updateUser(this.oModel.getOwnUser()[0], false);
                        break;   
      
          default:
            this.oLogger.warn("doWithUser: unbekannte Aufforderung:"+what2do);
            break;
        }    
  },    

}
