/**
 * class avatarIdController
 *   
 * Der Controller ist die Eingabeschnittstelle zwischen Benutzer und Modell.
 * Er interpretiert die empfangenen Eingabedaten und bergibt sie dem Modell.
 * Ein Controller ist meist auf ein spezielles View zugeschnitten. Ist sein 
 * Verhalten vom Model abhngig, so muss er auch auf nderungen im Model
 * reagieren knnen.
 * 
 * @author lray
 * @version 2007-02-21
 */    

  var AvatarIdControl = Class.create();

  AvatarIdControl.prototype = {

    oModel: Object(),
    oLogger:Object(),  
    sName: String("AvatarIdController"),
    oUser: Object(),
    oVTnTIdControl: Object(),
    oVTnTIdImage: Object(),

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName, oUser )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
      } else this.oLogger.warn("AvatarIdControl.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      
      if (oUser instanceof User) {
        this.oUser = oUser;
      } else this.oLogger.warn("AvatarIdControl.initialize: User-Object nicht bergeben, laufe im Leerlauf!")

    },

  /**
   * Setzt Model und View zurck.
   */
    release: function()
    {
      this.oModel = null;
    },

    toString: function()
    {
      return this.sName;
    },
  
/**
 *              <form action="javascript:updateUserDetails();">
 *           <fieldset id="personalities">
 *             <img src="" id="personalitiesPicture" width="80" height="80" style="float: left;"/>
 *             <legend>Personalien</legend>
 *           	<label for="nickInput">Nickname</label>
 *           	<input type="text" value="" id="nickInput"  /> 
 *           	<label for="nameInput">Name</label>
 *           	<input type="text" value="" id="nameInput" /> 
 *           	<label for="companyInput">Firma</label>
 *           	<input type="text" value="" id="companyInput" /> 
 *           	<label for="positionInput">Position</label>
 *           	<input type="text" value="" id="positionInput" /> 
 *           	<label for="mailInput">E-Mail</label>
 *           	<input type="text" value="" id="mailInput" />
 *             <br /><input type="submit" value="okay" /> 
 *           </fieldset>
 *         </form>
 */

 setProperties : function() {
        this.oUser.setNick($('nickInput').value);
        this.oUser.setName($('nameInput').value); 
        this.oUser.setCompany($('companyInput').value); 
        this.oUser.setPositionName($('positionInput').value); 
        this.oUser.setEmail($('mailInput').value); 

        this.oModel.updateUser(this.oUser);                
 }
  /* --------------------------------------------------*/
  // handleEvent-Methode


}
