/**
 * Class MapView
 *
 * erlaubt die Darstellung der Map, also Webshop-Sitemap.
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model. 
 * 
 * @author lray
 * @version 2007-02-28
 */
 
  var MapView = Class.create();

  MapView.prototype = {

    oModel: Object(),
    oLogger:Object(),  
    sName: String("MapView"),
    oUser: Object(),
    oVTnTMapView: Object(),
    oVTnTMapViewDetail1: Object(),
    oVTnTMapViewDetail2: Object(),
    oVTnTMapViewDetail3: Object(),
    oVTnTMapViewDetail4: Object(),            

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
        this.oModel.addObserver(this);      

      } else this.oLogger.warn("MapView.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      
      this.oVTnTMapView = document.createElementNS(svgNS,"g")
      
      if (this.oModel.getProducts() != null && this.oModel.getProducts().length >0) {
      	this.generateSource();      
      }

    },

    generateSource: function() {
        this.oLogger.debug("generating source1")
        this.oVTnTMapView.appendChild(this.oModel.getProducts().paint());
    },

    notify: function(m, o) {
     if( this.oModel == m && (!isNaN(parseInt(o.zoomLevel)))) { 
        if (!isNaN(parseInt(o.zoomLevel)) ) {
          this.setDetailLevel(o.zoomLevel);
          }
      };
      
      if( this.oModel == m && (o.products == true)) { 
		this.generateSource();
		this.paint();
      }
    },

    update: function(aUser) {
/*        for (var i=0; i< aUser.length; i++)
          if (aUser[i] == this.oUser.getId()) {
            this.oLogger.warn("AvatarIdView.notify: updating User "+aUser[i]);
            $("nickInput").value    = this.oUser.getNick(); 
            $("nameInput").value    = this.oUser.getName();
            $("companyInput").value = this.oUser.getCompany();
            $("positionInput").value= this.oUser.getPositionName();
            $("mailInput").value    = this.oUser.getEmail();
            $("personalitiesPicture").setAttribute('src',this.oUser.getPicUrl());
            return;
          }
        this.oLogger.debug("AvatarIdView.update: keine Aenderung ");
        */
    },

    paint: function() {
      return this.oVTnTMapView;
    },

    toString: function()
    {
      return this.sName;
    },
  
    setParent: function() {},

    setDetailLevel: function(detailLevel) {
        try {this.oVTnTMapView.removeChild(this.oVTnTMapViewDetail2);} catch (e) {};
        try {this.oVTnTMapView.removeChild(this.oVTnTMapViewDetail3);} catch (e) {};
        try {this.oVTnTMapView.removeChild(this.oVTnTMapViewDetail4);} catch (e) {};
        
        if (detailLevel >= 1.01)   {
//          this.oVTnTMapView.appendChild(this.oVTnTMapViewDetail2);
  /*          document.getElementsByClassName('mapLayer3').each(function(value){value.setAttribute("opacity",(0))});
            document.getElementsByClassName('mapLayer4').each(function(value){value.setAttribute("opacity",(0))});            
          this.oLogger.info("mapView.setDetailLevel: adding Layer 2");
          (detailLevel < 1.7) ? document.getElementsByClassName('mapLayer2').each(function(value){value.setAttribute("opacity",((detailLevel-1.01)*1.5))})
                              : document.getElementsByClassName('mapLayer2').each(function(value){value.setAttribute("opacity",1.0)});
*/        };

        if (detailLevel >= 1.2) {
  //        document.getElementsByClassName('mapLayer4').each(function(value){value.setAttribute("opacity",(0))});
      //    this.oLogger.info("mapView.setDetailLevel: adding Layer 3");
/*          if (detailLevel < 1.8) {
            document.getElementsByClassName('mapLayer3').each(function(value){value.setAttribute("opacity",((detailLevel-1.4)*1.5))})
            document.getElementsByClassName('mapLayer1').each(function(value){value.setAttribute("opacity",(1-((detailLevel-1.1)*1.5)))})
            }
          else
            document.getElementsByClassName('mapLayer3').each(function(value){value.setAttribute("opacity",1.0)});
*/          
        };

        if (detailLevel >= 1.5){
    //      this.oVTnTMapView.appendChild(this.oVTnTMapViewDetail4);
/*          (detailLevel < 2.1) ? document.getElementsByClassName('mapLayer4').each(function(value){value.setAttribute("opacity",((detailLevel-1.7)*1.5))})
                              : document.getElementsByClassName('mapLayer4').each(function(value){value.setAttribute("opacity",1.0)});
  */        
        };


    },
  
  /* --------------------------------------------------*/
  // handleEvent-Methode
    setAction: function(sAction) {
      this.oVTnTIdControl.setAttribute('action','javascript:'+sAction);
    },

    
}
