/**
 * class ProductDetailsView
 *   
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model. 
 * 
 * @author lray
 * @version 2007-02-16
 */    

  var ProductDetailsView = Class.create();

  ProductDetailsView.prototype = {

    oModel: Object(),
    oLogger:Object(),  
    sName: String("ProductDetailsView"),
    oProduct: Object(),
    oVTnTProductDetails: Object(),
    oMyImage: Object(),
    
    aElements: Array(),
    

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
        this.oModel.addObserver(this);      

      } else this.oLogger.warn("ProductIdView.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      
      this.oProduct = new Product();

      this.aElements = new Array();

      this.generateSource();      

    },

    notify: function(m, o) {
     if( this.oModel == m) { 
        if (o.detailedProduct instanceof Product) {
            this.update(o.detailedProduct);
        }
        else 
          this.clearProduct();
        } 
     else this.oLogger.debug("ProductIdView.notify: Object ("+typeof(o)+") Array:"+(o instanceof Array));   
    },


    update: function(oProduct) {
        this.oProduct = oProduct;
        this.oLogger.debug("ProductDetailsView.update: keine Aenderung ");
        this.fillProductDetails();
    },

    setProduct: function(oProduct) {
      this.update(oProduct);
    },

    clearProduct: function() {
/*      this.oVTnTProductDetails.setAttribute("style","display:none;");*/
    },

    paint: function() {
      return this.oVTnTProductDetails;
    },

    toString: function()
    {
      return this.sName;
    },
  
  /* --------------------------------------------------*/
  // handleEvent-Methode
    setAction: function(sAction) {
      this.oVTnTProductDetails.setAttribute('action','javascript:'+sAction);
    },

        /**
         * generateSource
         * 
         * erzeugt die zur Darstellung bentigte XML-Struktur.
         * 
         * @author lray
         * @version 2007-03-30                                             
         */      
        generateSource: function() {
            this.oVTnTProductDetails = document.createElementNS(xhtmlNS,'div');
            this.oVTnTProductDetails.setAttribute('id','ProductDetails');
            this.oVTnTProductDetails.setAttribute('class','prod_details');           
            
            var oVTnTProductDL = document.createElementNS(xhtmlNS,'dl');                     
            var detailData = new Array( "ID","Name","Link","ShortDescription","Description","Pic");
                   
            for (var i=0; i<(detailData.length -1 );i++){
              var oNewProductDetailsNode = document.createElementNS(xhtmlNS,'dt');
              var oNewProductDetailsNode2 = document.createElementNS(xhtmlNS,'dd');              
              var oNewProductDetailsTextNode = document.createTextNode(detailData[i]);             
              oNewProductDetailsNode.setAttribute("class","product_detail_"+detailData[i]);
              oNewProductDetailsNode2.setAttribute("class","product_detail_"+detailData[i]);              
              this.aElements[i] = document.createTextNode("tst");
              oNewProductDetailsNode.appendChild(oNewProductDetailsTextNode);
              oNewProductDetailsNode2.appendChild(this.aElements[i]);
              oVTnTProductDL.appendChild(oNewProductDetailsNode);
              oVTnTProductDL.appendChild(oNewProductDetailsNode2);              
            };

            var oNewProductDetailsNode = document.createElementNS(xhtmlNS,'dt');
            var oNewProductDetailsNode2 = document.createElementNS(xhtmlNS,'dd');
            var oNewProductDetailsTextNode = document.createTextNode(detailData[detailData.length-1]);             
            oNewProductDetailsNode.appendChild(oNewProductDetailsTextNode);
            this.oMyImage = document.createElementNS(xhtmlNS,"img");
            this.aElements[detailData.length-1] = document.createTextNode("tst");
            this.oMyImage.setAttribute("src",this.aElements[detailData.length-1]);
            this.oMyImage.setAttribute("width",80);
            this.oMyImage.setAttribute("height",80);
            oNewProductDetailsNode2.appendChild(this.oMyImage);
            oVTnTProductDL.appendChild(oNewProductDetailsNode);
            oVTnTProductDL.appendChild(oNewProductDetailsNode2);              
            this.oVTnTProductDetails.appendChild(oVTnTProductDL);
            
            this.fillProductDetails();
        },    

     fillProductDetails: function() {
          this.aElements[0].data = this.oProduct.getId();
          this.aElements[1].data = this.oProduct.getName();
          this.aElements[2].data = this.oProduct.getLinkUrl();
          this.aElements[3].data = this.oProduct.getShortDesc();
          this.aElements[4].data = this.oProduct.getDescription();
          this.aElements[5].data = this.oProduct.getPicUrl();
          this.oMyImage.setAttribute("src",this.aElements[5].data);
          
          /*this.oVTnTProductDetails.setAttribute('style','display:block;position:absolute;left:'
            +(this.oModel.viewPortX(this.oProduct.getX())+100)+'px;top:'
            +(this.oModel.viewPortY(this.oProduct.getY())+20)+'px;');*/
     } 
}
