/**
 * Class sliderView
 *
 * erlaubt die Darstellung der Map, also Webshop-Sitemap.
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model.
 * 
 * SliderView steuert den Slider, welcher auf der VisualMap das ZOOMING inner.
 * halb der Karte ermglicht.   
 * 
 * @author lray
 * @version 2007-02-28
 */
 
  var SliderView = Class.create();

  SliderView.prototype = {

    oModel: Object(),
    ocontrol: Object(),
    oLogger:Object(),  
    sName: String("SliderView"),
    oVTnTSliderView: Object(), 
    oVTnTSlider: Object(),
    oVTnTSliderTextNode: Object(),              
    // TODO: Buggy, da durch tiefere Ebene vereinbart.
    sClassPath: String(),
    iDetailLevel: Number(0),

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName, sClassPath )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
        this.oModel.addObserver(this);      

      } else this.oLogger.warn("SliderView.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      if (sClassPath != null) this.sClassPath = sClassPath;
      else this.sClassPath = sName;

      this.generateSource();
      
      this.oControl = this.makeControl( oModel, this);

    },

  /**
   * Erzeugt ein Control-Componente.   
   * @return Control fuer View
   */
    makeControl: function( ) {
        return new SliderControl( this.oModel, this );
    },

    getControl: function() {
      //alert(this.oControl.toString());
      return this.oControl;
    },

    notify: function(m, o) {
     if( this.oModel == m && (o.user instanceof Array)) { 
        if (!isNaN(parseInt(o.zoomLevel)) ) {
          this.setDetailLevel(o.zoomLevel);
          }
      }    
    },

    paint: function() {
      return this.oVTnTSliderView;
    },

    toString: function()
    {
      return this.sName;
    },
  
    setParent: function() {},

    setDetailLevel: function(detailLevel) {
      this.iDetailLevel = Math.round((detailLevel-0.2)/0.03);
      this.oVTnTSlider.setAttribute("x",30+this.iDetailLevel);
      this.oVTnTSliderTextNode.data = this.iDetailLevel;
    },
  
  /* --------------------------------------------------*/
  // handleEvent-Methode
    setAction: function(sAction) {
      this.oVTnTIdControl.setAttribute('action','javascript:'+sAction);
    },

        generateSource: function() {

            this.oVTnTSliderView = document.createElementNS(svgNS,'g');
            this.oVTnTSliderView.setAttribute('id','slider');
            this.oVTnTSliderView.setAttribute('transform','translate(10,5)');
            
            this.oVTnTSliderView.setAttribute("onmousedown",this.sClassPath+".getControl().start=true;"+
                                                            this.sClassPath+".getControl().moveSlider(evt)");
            this.oVTnTSliderView.setAttribute("onmouseup",  this.sClassPath+".getControl().start=false;"+
                                                            this.sClassPath+".getControl().releaseSlider(evt)");
            this.oVTnTSliderView.setAttribute("onmousemove",this.sClassPath+".getControl().moveSlider(evt)");
            this.oVTnTSliderView.setAttribute("onclick",    this.sClassPath+".getControl().moveSlider(evt)");
            
            var oVTnTSliderText1 = document.createElementNS(svgNS,'text');
            oVTnTSliderText1.setAttribute("class","vTnTSliderText");
            oVTnTSliderText1.setAttribute("x","0");
            oVTnTSliderText1.setAttribute("y","8");
            oVTnTSliderText1.appendChild(document.createTextNode("Zoom:"));
            
            this.oVTnTSliderTextNode = document.createTextNode(this.iDetailLevel)
            
            var oVTnTSliderText2 = document.createElementNS(svgNS,'text');            
            oVTnTSliderText2.setAttribute("class","vTnTSliderText");
            oVTnTSliderText2.setAttribute("x","140");
            oVTnTSliderText2.setAttribute("y","8");
            oVTnTSliderText2.appendChild(this.oVTnTSliderTextNode);

            var oVTnTSliderBG    = document.createElementNS(svgNS,'rect');
            oVTnTSliderBG.setAttribute("class","vTnTSliderBG");
            oVTnTSliderBG.setAttribute("x","30");
            oVTnTSliderBG.setAttribute("y","3");
            oVTnTSliderBG.setAttribute("height","4");
            oVTnTSliderBG.setAttribute("width","100");

            this.oVTnTSlider      = document.createElementNS(svgNS,'rect');
            this.oVTnTSlider.setAttribute("class","vTnTSlider");
            this.oVTnTSlider.setAttribute("x",30+this.iDetailLevel);
            this.oVTnTSlider.setAttribute("y","0");
            this.oVTnTSlider.setAttribute("height","10");
            this.oVTnTSlider.setAttribute("width","3");
            
            this.oVTnTSliderView.appendChild(oVTnTSliderText1);            
            this.oVTnTSliderView.appendChild(oVTnTSliderText2);
            this.oVTnTSliderView.appendChild(oVTnTSliderBG);
            this.oVTnTSliderView.appendChild(this.oVTnTSlider);
        },    


}
 

