/** 
 * Objekt Avatar
 * 
 * verwaltet die Eigenschaften eines Avatars
 * 
 * @author lray
 * @version 2007-02-15
 */       

  var User = Class.create();
  User.prototype = {
    
    oLogger:Object(),   
    iXPos:Number(0),
  	iYPos:Number(0),
    sID:String(),
  	bActive:Boolean(),
  	iLoudness:Number(),
  	bOwnAvatar: Boolean(),
  	bBlocked: Boolean(false),

    iLastAction: Number(),
  	dLastMoved: Date(),
  	dLastSeen: Date(),
 	
  	sName:String(),
    sNick: String(),
    sCompany: String(),
    sPositionName: String(),
    sPicUrl: String(),
    sEmail:String(),

    initialize: function() {
         //open maingroup
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.oLogger.debug("User initiated");
      this.dLastMoved = 0;
  
    },

    notify: function() {
      this.oLogger.warn("Class "+this.getId()+" notified, but not yet implemented.");
    },

    remove: function() {
    },

  	setX: function(xpos) { 
      this.iXPos = Math.floor(xpos);
    },
  	getX: function() { return this.iXPos;},

    setLastMoved: function(lastMoved) {
      this.dLastMoved = lastMoved;
      this.oLogger.debug("User.setLastMoved: "+this.getId()+" set to "+lastMoved);
    },

    getLastMoved: function() {
      return this.dLastMoved;
    },
 
    setLastSeen: function(lastSeen) {
      this.dLastSeen = lastSeen;
    },
    
    getLastSeen: function() {
      return this.dLastSeen;
    },

  	setY: function(ypos) {
      this.iYPos = Math.floor(ypos);
    },
  	getY: function() {return this.iYPos;},

  	setName: function(name) {
      this.oLogger.debug("User.setName: "+this.getId()+" set to "+name);
      this.sName = name;
    },
  	getName: function() {return this.sName;},
  	
  	setBlocked: function(blocked) {
      this.bBlocked = Boolean(blocked);
    },
  	getBlocked: function() {return this.bBlocked;},

  	toString: function() {return this.sName;},

  	setNick: function(name) {
      //this.oLogger.debug("User.setNick: "+this.getId()+" set to "+name);
      this.sNick = name;
    },
  	getNick: function() {return this.sNick;},

  	setCompany: function(company) {
      //this.oLogger.debug("User.setCompany: "+this.getId()+" set to "+company);
      this.sCompany = company;
    },
  	getCompany: function() {return this.sCompany;},

  	setPositionName: function(posName) {
      //this.oLogger.debug("User.setPositionName: "+this.getId()+" set to "+posName);
      this.sPositionName = posName;
    },
  	getPositionName: function() {return this.sPositionName;},

  	setPicUrl: function(picUrl) {
      //this.oLogger.debug("User.setPicURL: "+this.getId()+" set to "+picUrl);
      this.sPicUrl = picUrl;
    },
  	getPicUrl: function() {return this.sPicUrl;},

  	setId: function(id) {
      this.oLogger.debug("User.setId: from "+this.sID+" to "+id);
      this.sID = Number(id);
    },
  	getId: function() {return this.sID;},
  
  	setLoudness: function(loudness) {
      //this.oLogger.debug("User.setLoudness: "+this.getId()+" set to "+loudness);
      if (loudness >= 0)
        this.iLoudness = loudness;
      else this.iLoudness = 0;
    },
  	
    getLoudness: function() {return this.iLoudness;},

  	setActive: function(active) {
      //this.oLogger.warn("User.setActive: "+active+" ("+(typeof active)+")");
      this.bActive = Boolean(active);
      if (!isNaN(active)) this.bActive = Boolean(Number(active));
      if (active == "0")	 this.bActive = false;
      if (active == "false") this.bActive = false;
      if (active =="true")	 this.bActive = true;
    },
  	
    isActive: function() {return this.bActive;},

  	setOwn: function(own) {
      this.bOwnAvatar = own;
    },
  	
    isOwn: function() {
      return this.bOwnAvatar;
    },

  	// Was heisst "iSec" ?
    setLastAction: function(lastAction) {
      this.iLastAction = lastAction;
      //this.oLogger.debug("User.setLastAction ("+this.getId()+"):"+lastAction);
    },
  	getLastAction: function() {return this.iLastAction;},

  	setLastMoved: function(lastMoved) {
      //this.oLogger.debug("User.setLastMoved: "+this.getId()+" set to "+lastMoved);
      this.dLastMoved = lastMoved;
    },
  	getLastMoved: function() {return this.dLastMoved;},

  	setEmail: function(item) {
      this.sEmail = item;
      this.oLogger.debug("User.setEmail: "+this.getId()+" set to "+item);
/*      if (this.getPicUrl() == ""||this.getPicUrl().substring(0,23)=="http://www.gravatar.com" ) {
            this.setPicUrl('http://www.gravatar.com/avatar.php?gravatar_id='+MD5(this.getEmail()));
            this.oLogger.debug("User.setEmail: "+this.getEmail()+" zu "+MD5(this.getEmail()));
            }*/
      },
  	getEmail: function() {return this.sEmail;},

    /**
     *setLastSeen
     *
     *hlt den Timestamp des letzten Signals vom Nutzer direkt
     *
     * @param Date lastSeen - Timestamp
     * @author: lray
     * @version:  2007-02-14
     **/                             
  	setLastSeen: function(lastSeen) {
      this.dLastSeen = lastSeen;
      //this.oLogger.debug("User.setLastSeedn: "+this.getId()+" set to "+lastSeen);
    },
  	getLastSeen: function() {return this.dLastSeen;},	

}
