Effect.SVGMove = Class.create();
Object.extend(Object.extend(Effect.SVGMove.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    var options = Object.extend({
      x:    0,
      y:    0,
      mode: 'relative'
    }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Bug in Opera: Opera returns the "real" position of a static element or
    // relative element that does not have top/left explicitly set.
    // ==> Always set top and left for position relative elements in your stylesheets 
    // (to 0 if you do not need them) 
    Element.makePositioned(this.element);
    var sTransform = this.element.getAttribute('transform');
    this.originalLeft = parseFloat(
	sTransform.substring((sTransform.indexOf('(')+1),sTransform.indexOf(',')) || '0');
    this.originalTop  = parseFloat(
	sTransform.substring((sTransform.indexOf(', ')+1),sTransform.indexOf(')'))  || '0');

    if (isNaN(this.originalLeft)) this.originalLeft = 0;
    if (isNaN(this.originalTop))  this.originalTop = 0;
    
    if(this.options.mode == 'absolute') {
      // absolute movement, so we need to calc deltaX and deltaY
      this.options.x = this.options.x - this.originalLeft;
      this.options.y = this.options.y - this.originalTop;
    }
  },
  update: function(position) {
     var newX = Math.round(this.options.x  * position + this.originalLeft);
     var newY = Math.round(this.options.y  * position + this.originalTop);
     var newString ='translate(' + String(newX+', '+newY)+')'; 

     this.element.setAttribute('transform',newString);
    Element.setStyle(this.element, {
      transform: newString
    });
  }
});

Effect.SVGMapResize = Class.create();
Object.extend(Object.extend(Effect.SVGMapResize.prototype, Effect.Base.prototype), {
    initialize: function(element) {
    this.element = $(element);
      var options = Object.extend({
      width:    0,
      height:    0,
      mode: 'relative',
      float: 'left'
    }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Bug in Opera: Opera returns the "real" position of a static element or
    // relative element that does not have top/left explicitly set.
    // ==> Always set top and left for position relative elements in your stylesheets 
    // (to 0 if you do not need them) 
    Element.makePositioned(this.element);
         
    this.originalWidth = parseFloat(Element.getStyle(this.element,'width') || '0');
    this.originalHeight  = parseFloat(Element.getStyle(this.element,'height') || '0');

    if (isNaN(this.originalWidth)) this.originalWidth = 0;
    if (isNaN(this.originalHeight))  this.originalHeight = 0;
    
    if (this.options.float == 'right') {
    	var sTransform = this.element.getAttribute('transform');
	    
	    try {
	    	this.originalX = parseFloat(
				sTransform.substring((sTransform.indexOf('(')+1),sTransform.indexOf(',')) || '0');
	    } catch (e) {};
	    
	    try {
	    	this.originalY  = parseFloat(
				sTransform.substring((sTransform.indexOf(', ')+1),sTransform.indexOf(')'))  || '0');
	     } catch (e) {};
	      
	    if (isNaN(this.originalX)) this.originalX = 0;
	    if (isNaN(this.originalY))  this.originalY = 0;   

	    this.newXPos = this.originalX - (this.options.width - this.originalWidth);
	    this.newYPos = this.originalY - (this.options.height - this.originalHeight);

    }
  },
  update: function(position) {
     var newWidth = Math.round(this.originalWidth + ((this.options.width-this.originalWidth) * position ));
     var newHeight = Math.round(this.originalHeight + ((this.options.height-this.originalHeight)  * position));

	if (this.options.float == 'right') {
	     var newX = Math.round(this.originalX - ((this.options.width - this.originalWidth) * position));
	     var newY = Math.round(this.originalY - ((this.options.height - this.originalHeight) * position));
	     var newString ='translate(' + String(newX+', '+newY)+')'; 

	     this.element.setAttribute('transform',newString);
	     Element.setStyle(this.element, {transform: newString });
	}

      Element.setStyle(this.element, {
	      width: newWidth+'px',
    	  height:   newHeight  + 'px',
    });
 }
});

Effect.DivResize = Class.create();
Object.extend(Object.extend(Effect.DivResize.prototype, Effect.Base.prototype), {
    initialize: function(element) {
    this.element = $(element);
      var options = Object.extend({
      width:    0,
      height:    0,
      mode: 'relative',
      float: 'left',
      verticalAlign: 'top', 
    }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Bug in Opera: Opera returns the "real" position of a static element or
    // relative element that does not have top/left explicitly set.
    // ==> Always set top and left for position relative elements in your stylesheets 
    // (to 0 if you do not need them) 
    Element.makePositioned(this.element);
         
    this.originalWidth = parseFloat(Element.getStyle(this.element,'width') || '0');
    this.originalHeight  = parseFloat(Element.getStyle(this.element,'height') || '0');

    if (isNaN(this.originalWidth)) this.originalWidth = 0;
    if (isNaN(this.originalHeight))  this.originalHeight = 0;
    
    if (this.options.verticalAlign == 'bottom') {
    	this.originalY  = parseFloat(Element.getStyle(this.element,'top') || '0');
	    if (isNaN(this.originalY))  this.originalY = 0;   
	    this.newYPos = this.originalY - (this.options.height - this.originalHeight); 
    }
    
    if (this.options.float == 'right') {
	    
	    this.originalX = parseFloat(Element.getStyle(this.element,'left') || '0');
 	      
	    if (isNaN(this.originalX)) this.originalX = 0;

	    this.newXPos = this.originalX - (this.options.width - this.originalWidth);
    }
  },
  update: function(position) {
     var newWidth = Math.round(this.originalWidth + ((this.options.width-this.originalWidth) * position ));
     var newHeight = Math.round(this.originalHeight + ((this.options.height-this.originalHeight)  * position));

	if (this.options.float == 'right') {
	     var newX = Math.round(this.originalX - ((this.options.width - this.originalWidth) * position));

	     //var newString ='translate(' + String(newX+', '+newY)+')'; 
	     //this.element.setAttribute('transform',newString);

	     Element.setStyle(this.element, {left: newX+'px'});
	}
	
	if (this.options.verticalAlign == 'bottom') {
	     var newY = Math.round(this.originalY - ((this.options.height - this.originalHeight) * position));
	     Element.setStyle(this.element, {top: newY+'px'});
	}

      Element.setStyle(this.element, {
	      width: newWidth+'px',
    	  height:   newHeight  + 'px',
    });
 }
});